function [spec_mat]=spec_mat_comp(weight_func,L,Lag)
    %Ginters Buss 2012
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % if useful, cite Ginters Buss "Real-time signal extraction with
    % regularized multivariate direct filter approach",
    % in Journal of Forecasting
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % translated from Wildi I-mdfa_new6.r code 
    % New 2012 code: is needed for implementing spectral matrix in new 
    % parametrization including regularization
    % [spec_mat]=spec_mat_comp(weight_func,L,Lag)
    K=length(weight_func(:,1))-1;
    weight_h=weight_func;
    sizewf=size(weight_func);
    % Frequency zero receives half weight
    weight_h(1,:)=weight_h(1,:)*0.5;
    % Extract DFT target variable (first column)
    weight_target=weight_h(:,1);
    % Rotate all DFT's such that weight_target is real 
    % (rotation does not alter mean-square error)
    weight_h=weight_h.*(exp(-1i*angle(weight_target))*ones(1,sizewf(2)));
    weight_target=weight_target.*exp(-1i*angle(weight_target));
    % DFT's explaining variables (target variable can be an explaining variable too)
    weight_h_exp=weight_h(:,2:end);
    sizewhe=size(weight_h_exp);
    spec_mat=reshape(ones(L,1)*weight_h_exp(1,:),[],1);
    for j = 1:K
        omegak=j*pi/K;
        exp_vec=exp(1i*omegak*((0:L-1)-Lag));
        spec_mat=[spec_mat,reshape(kron(weight_h_exp(j+1,:),exp_vec),[],1)];
    end
 