function XSA = x12(X,Frequency,Start,OnOff,arima,forecast,regression,transform,x11,x11regression)

% Delete NA's %%%%%%%%%%%%%

XNAN=isnan(X);

if sum(XNAN)>0,
    for i=size(XNAN,1):-1:1
        if XNAN(i)==1, X(i)=[]; end
    end
end





% spc File %%%%%%%%%%%%%%%%%

dlmwrite('x12data.spc', '', 'delimiter', '', 'newline', 'pc')



% series %%%%%%%%%%%%%%%%%%%

dlmwrite('x12data.spc', 'series{title = "x"', '-append', 'delimiter', '', 'newline', 'pc')

dlmwrite('x12data.spc', 'data = (', '-append', 'delimiter', '', 'newline', 'pc')
dlmwrite('x12data.spc', X, '-append', 'delimiter', '', 'newline', 'pc')
dlmwrite('x12data.spc', ')', '-append', 'delimiter', '', 'newline', 'pc')

if isequal(Frequency,'M')==1,dlmwrite('x12data.spc', 'period = 12', '-append', 'delimiter', '', 'newline', 'pc'), end
if isequal(Frequency,'Q')==1,dlmwrite('x12data.spc', 'period = 4', '-append', 'delimiter', '', 'newline', 'pc'), end

dlmwrite('x12data.spc', ['start = ', Start, '}'], '-append', 'delimiter', '', 'newline', 'pc')







% arima %%%%%%%%%%%%%%%%%%%%

if isequal(arima,{'skip'})==0,
    dlmwrite('x12data.spc', 'arima{', '-append', 'delimiter', '', 'newline', 'pc')
    for row=1:size(arima,2)
        dlmwrite('x12data.spc', arima(1,row), '-append', 'delimiter', '', 'newline', 'pc')
    end
    dlmwrite('x12data.spc', '}', '-append', 'delimiter', '', 'newline', 'pc')
end

% forecast %%%%%%%%%%%%%%%%%%%%%

if isequal(forecast,{'skip'})==0,
    dlmwrite('x12data.spc', 'forecast{', '-append', 'delimiter', '', 'newline', 'pc')
    for row=1:size(forecast,2)
        dlmwrite('x12data.spc', forecast(1,row), '-append', 'delimiter', '', 'newline', 'pc')
    end
    dlmwrite('x12data.spc', '}', '-append', 'delimiter', '', 'newline', 'pc')
end

% regression %%%%%%%%%%%%%%%%%%%%%

if isequal(regression,{'skip'})==0,
    dlmwrite('x12data.spc', 'regression{', '-append', 'delimiter', '', 'newline', 'pc')
    for row=1:size(regression,2)
        dlmwrite('x12data.spc', regression(1,row), '-append', 'delimiter', '', 'newline', 'pc')
    end
    dlmwrite('x12data.spc', '}', '-append', 'delimiter', '', 'newline', 'pc')
end

% transform %%%%%%%%%%%%%%%%%%%%%

if isequal(transform,{'skip'})==0,
    dlmwrite('x12data.spc', 'transform{', '-append', 'delimiter', '', 'newline', 'pc')
    for row=1:size(transform,2)
        dlmwrite('x12data.spc', transform(1,row), '-append', 'delimiter', '', 'newline', 'pc')
    end
    dlmwrite('x12data.spc', '}', '-append', 'delimiter', '', 'newline', 'pc')
end

% x11 %%%%%%%%%%%%%%%%%%%%%

dlmwrite('x12data.spc', 'x11{', '-append', 'delimiter', '', 'newline', 'pc')
for row=1:size(x11,2)
    dlmwrite('x12data.spc', x11(1,row), '-append', 'delimiter', '', 'newline', 'pc')
end
dlmwrite('x12data.spc', 'save=(d11)', '-append', 'delimiter', '', 'newline', 'pc')
dlmwrite('x12data.spc', '}', '-append', 'delimiter', '', 'newline', 'pc')

% x11regression %%%%%%%%%%%%%%%%%%%%%

if isequal(x11regression,{'skip'})==0,
    dlmwrite('x12data.spc', 'x11regression{', '-append', 'delimiter', '', 'newline', 'pc')
    for row=1:size(x11regression,2)
        dlmwrite('x12data.spc', x11regression(1,row), '-append', 'delimiter', '', 'newline', 'pc')
    end
    dlmwrite('x12data.spc', '}', '-append', 'delimiter', '', 'newline', 'pc')
end


% Emplty output file %%%%%%%%%

fid = fopen('x12data.d11','w');
fprintf(fid,'%0s \t %0s \n','date','x12data.d11');
fprintf(fid,'%0s \t %0s \n','------','-----------------------');
fprintf(fid,'%0s \t %0s \n','1','NaN');
fclose(fid);

% Execute %%%%%%%%%%%%%%%%%

!x12a.exe -i x12data -n

% Output %%%%%%%%%%%%%%%%%%

XSA = dlmread('x12data.d11','',2,1);

% Insert NA's %%%%%%%%%%%%%

if isnan(XSA)==0,
    if sum(XNAN)>0,
        XSA_adj=NaN(size(XNAN,1),1);
        i=1;
        while XNAN(i)==1, i=i+1; end
        XSA_adj(i:i+size(XSA,1)-1)=XSA;
        XSA=XSA_adj;
    end
end

% Delete files %%%%%%%%%%%%%%

delete('x12data.d11', 'x12data.err', 'x12data.log', 'x12data.out', 'x12data.spc');

if isequal(OnOff,'Off')==1, clc; end