function [b,trf,vari,reveragav,aicagav,dgrav,weight_constraint]=rmdfa_fn(dgdpint,edat,squeeze,garch,numbseries,maxfilterlength,minfilterlength,rtio,pp,expweight,...
  Lag,  lambda,usefactors,nfactors,ftype,filterdepvar,nostand,standtarget,i1,i2, ...
  weightbycorr,lambda_decay,lambda_cross,lambda_smooth,playground,freqdom,...
  ord, ub,lb,lin_expweight)
    %Ginters Buss 2012
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % if useful, cite Ginters Buss "Real-time signal extraction with
    % regularized multivariate direct filter approach",
    % in Journal of Forecasting
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%addpath(genpath('C:\Users\gintersb\data\matlab\myfunc')) % get mdfa(), periodogram_bp(), nchoosek_re(); the last one lists combinations, no help provided
%addpath(genpath('C:\Users\gintersb\data\matlab\external codes\Sheppard financial\MFEToolbox')) % garch



% squeeze=1; % if =1 squeezes the last bit of information; 0-no
% garch=0; % garch(1) or no garch(0) of explan vars
% numbseries=100;  %how many explan series at a time, in filter; inf or a big # if all
% maxfilterlength=12;
% minfilterlength=12;
% rtio=1.1; %1.1 %1.2-3.6
% pp=1; %power for MSFE weights
% expweight=0; %.5 %1.9
% Lag=0; %-7
% lambda=0;  %15
% usefactors=0; % use princomp or original data
%     nfactors=15; % # factors; only if usefactors=1
%     ftype='outer'; % 'outer', 'corr' or ' cov'    
% filterdepvar=0; % filter dep var or not; doesn't seem to help
% nostand=0; %1: do not scale the output by the variance of finite symm
% standtarget=0; %1: standardize the target variable before input in filter; not welcome;
% i1=1;   %Do not impose i1<-T for bandpass or highpass filters;necessary for low-pass filters applied to integrated time series (otherwise signal and real-time estimates are not cointegrated i.e. the filter error is not stationary). Do not impose the restriction in the case of bandpass filters (unless you are willing to endure inefficiency)
% i2=0;   % do not impose for true bandpass; i1<T and i2<-T are both necessary in the case of I(2) processes with a double unit-root in frequency zero (I don't know any application requiring an I(2) specification, though; My(Wildi) personal preference is i1<-F and i2<-T which cannot be realized by model-based approaches. 
% 
% weightbycorr=1; % weight amplitudes at zero freq for explan vars  by corr with dep var                          
    endsamp=size(dgdpint,1);   
% lambda_decay=0.2; %.1
% lambda_cross=0; %.01
% lambda_smooth=0; %0.000000000001;
% 
% playground=1; % 9/15 playground=[0,1] unity means lowpass if i1=1
% freqdom=0;  %0 - linearly interpolate gdp; 1 - frequency domain solution
% 
% 
% ord=9e5; %9e5 (ideal, fast)  %length of target/ideal filter; 
% ub=6;  %the same as 2pi/18
% lb=Inf;  %48(bandpass) or inf(lowpass); %



for i=1:size(edat,2)
    edat(:,i)=(edat(:,i)-mean(edat(:,i)))/std(edat(:,i));
end


if usefactors
[weights,princomp,eigenvals,explvar,cumr2]=pca(edat,ftype); %type: 'outer', 'cov' or 'corr'

edat=princomp(:,1:nfactors);
end


dgdpintsize=size(dgdpint);        
edatsize=size(edat);


for i=1:size(edat,2)
    edat(:,i)=(edat(:,i)-mean(edat(:,i)))/std(edat(:,i));
end


%{
%##### test for normality ##########
%kolmogorov
[stat,pval,H] = kolmogorov(edat(:,8),[],'normcdf',0,1)
% neither rejects the null of normality
%Jarque-Bera
[statistic, pval,H] = jarquebera(edat(:,8)) % 5 fails
% another JB
H=jbtest(edat(:,8))
%}

if garch==1
    options  =  optimset('fminunc');
    options.Display =  'off';

    for i=1:size(edat,2)
        [a1,a2,a3,a4,a5,a6,a7]=tarch(edat(:,i),1,0,1,[],[],[],options);
        edat(:,i)=edat(:,i)./sqrt(a3);   
    end
 
    
for i=1:size(edat,2)
    edat(:,i)=(edat(:,i)-mean(edat(:,i)))/std(edat(:,i));
end    
end

%plot data
%{
close all

figure('Position',[300 200 800 450])

plot([nan(11,1);(dgdpint-mean(dgdpint))/std(dgdpint)],'black','LineWidth',3)
hold on
plot(edat,'black','MarkerSize',3)
hold off
legend('yoy gdp','prod.ind','order.book.ind','stocks.ind','prod.expect.ind','empl.expect.ind','build.conf','retail.conf','consumers.conf','service.conf','Location','SouthWest')
    
datevar=edata1_dates(nsanumber+1:end,:);
sizedatevar=size(datevar);
for i=1:sizedatevar(1)
    tempdate=datevar{i};
    datevar{i}=tempdate(4:end);
end
nticks=fix((edatsize(1)+24)/24);
%title(strcat('Euro-light: monthly zero-lag real-time indicator, last obs: ',datevar(end)))
%ylabel('q-o-q GDP(green), symm.filt(red), q-o-q ind(blue), q-o-q Ecoin(black)')
axis([-Inf edatsize(1)+2 -Inf +Inf])
set(gca,'XTick',edatsize(1)+1-nticks*24+(1:nticks)*24)
if regdiffexplanvar==0
set(gca,'XTickLabel',[datevar(edatsize(1)-nticks*24+(1:nticks)*24)])
elseif regdiffexplanvar==1
set(gca,'XTickLabel',[datevar(edatsize(1)+1-nticks*24+(1:nticks)*24)])    
end
    
print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\data_yoy')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\data_yoy')


%}

%plot gdp vs cross-sectional mean and the first pc of expl data
%{
[weights,princomp,eigenvals,explvar,cumr2]=pca(edat,ftype); %ftype=outer,cov,corr
close all
set(0,'DefaultAxesColorOrder',[0 0 0;1 0 0;0 0 1],...
      'DefaultAxesLineStyleOrder','-|--.|-.|--|:|-+|-*|-s|-o|-v|-^')
figure('Position',[300 200 800 450])

plot([nan(11,1);(dgdpint-mean(dgdpint))/std(dgdpint)],'black','LineWidth',3)
hold on
plot([mean(edat,2),(princomp(:,1)-mean(princomp(:,1)))/std(princomp(:,1))],'black','MarkerSize',3)
hold off
legend('standardized yearly growth of gdp','cross-sectional mean of standardized expl. data','standardized first principal component of expl. data','Location','SouthWest')
    
datevar=edata1_dates(nsanumber+1:end,:);
sizedatevar=size(datevar);
for i=1:sizedatevar(1)
    tempdate=datevar{i};
    datevar{i}=tempdate(4:end);
end
nticks=fix((edatsize(1)+24)/24);
%title(strcat('Euro-light: monthly zero-lag real-time indicator, last obs: ',datevar(end)))
%ylabel('q-o-q GDP(green), symm.filt(red), q-o-q ind(blue), q-o-q Ecoin(black)')
axis([-Inf edatsize(1)+2 -Inf +Inf])
set(gca,'XTick',edatsize(1)+1-nticks*24+(1:nticks)*24)
if regdiffexplanvar==0
set(gca,'XTickLabel',[datevar(edatsize(1)-nticks*24+(1:nticks)*24)])
elseif regdiffexplanvar==1
set(gca,'XTickLabel',[datevar(edatsize(1)+1-nticks*24+(1:nticks)*24)])    
end
    
print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\mean_pca_yoy')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\mean_pca_yoy')

%}


%iipeur=(edata(22:end-1,end)-mean(edata(22:end-1,end)))/stdev(edata(22:end-1,end))


%plot([edat(:,1),iipeur])
% extract the data: in first differences (emphasize growth) - see below
% Define Data matrix:
% First column: target variable iip (target is symmetrical bandpass applied to IP) - see below
% Second to last columns: explaining variables (iip is included again, but now it's an explaining variable)


%-------------------------------------------------
% 2. INITIALIZATION OF FILTER PARAMETERS

% set parameters such that symmetric filter is replicated by one-sided
len=length(edat(:,1));

 insamp=fix((dgdpintsize(1))/2)*2;  %133
 leftinfo=dgdpintsize(1)-insamp;

    
    
if squeeze==1   
    insampspace=[insamp+leftinfo];  
else
    insampspace=[insamp];  
end


outofsamp=len-insamp;
filteroutputlength=len; %insamp+min(len-insamp,11); %len


% Number of frequency ordinates
K=(insamp)/2;

cutoff=pi/ub;
% length symmetric finite sample ideal filter (truncated symmetric of length 2*ord+1)
% order<-20 is not unnecessarily large (good compromise) because we want to benchmark the real-time design during the great recession

% Coefficients symmetric finite sample bandpass filter: difference of two lowpass
lambda1=pi/ub;
b1=[lambda1/pi,(1/pi)*sin(lambda1*(1:ord))./(1:ord)];
b1=b1/(sum(b1)+sum(b1(2:ord+1)));

%plot(b1)
%xs2jpg(0,'C:\Ginters\IKP flash\latex\dfa_intro\lowpass1')
%xs2pdf(0,'C:\Ginters\IKP flash\latex\dfa_intro\lowpass1')
%xs2eps(0,'C:\Ginters\IKP flash\latex\dfa_intro\lowpass1')  

if lb==inf
    b_sym=b1;
else
    lambda2=pi/lb;
    b2=[lambda2/pi,(1/pi)*sin(lambda2*(1:ord))./(1:ord)];
    b2=b2/(sum(b2)+sum(b2(2:(ord+1))));
    b_sym=b1-b2; % LOWPASS!!!!!!!!! bandpass: b1-b2
end
%clf; plot(b2)

%xs2jpg(0,'C:\Ginters\IKP flash\latex\dfa_intro\lowpass2')
%xs2pdf(0,'C:\Ginters\IKP flash\latex\dfa_intro\lowpass2')
%xs2eps(0,'C:\Ginters\IKP flash\latex\dfa_intro\lowpass2')  

%clf;plot(b_sym)

%xs2jpg(0,'C:\Ginters\IKP flash\latex\dfa_intro\symfilt')
%xs2pdf(0,'C:\Ginters\IKP flash\latex\dfa_intro\symfilt')
%xs2eps(0,'C:\Ginters\IKP flash\latex\dfa_intro\symfilt')  

%Transfer function of truncated ideal bandpass
% This Gamma is applied to iip: the output (bandpassed iip in first differences) is the target signal
% Levels can be obtained by the cusum of this series, if needed (see below)

if ord==9e5
    if lb==inf
        trffkt=zeros(K+1,1);
        trffkt(1:round((K+1)*(1/ub)))=1; %.143
    else
        trffkt_lb=zeros(K+1,1);
        trffkt=zeros(K+1,1);
        trffkt_lb(1:round((K+1)*(1/lb)))=1;
        trffkt(1:round((K+1)*(1/ub)))=1;
        trffkt=trffkt-trffkt_lb;
    end
else

    trffkt=zeros(K+1,1);
    for k = 0:K %#k<-0
        omegak=k*pi/K;
        trffkt(k+1)=b_sym*(cos(omegak*(0:ord)).*[1,2*ones(1,ord)])';
    end
end

%plot(trffkt)
Gamma=trffkt;
%Gamma<-rep(0,K+1)
%Gamma[1+(K/lb):(K/ub)]<-1

%plot(Gamma)
%a = gca();
%a.x_ticks = tlist(['ticks' 'locations' 'labels'],1+(0:6)*fix(K)/6,['0','pi/6','2pi/6','3pi/6','4pi/6','5pi/6','pi'])
%a.y_label.font_size = 2; 



% spectral weighting function: I'm using DFT's (discrete fourier transform)
% though you may supply model-based estimates or any spectral estimate
% Note that data from t=1 to t=insamp is used
% Note also that pseudo-periodogram is used for data in levels: I supply data in first differences to the periodogram function and d is set to one (mid-parameter in function-call)
% The pseudo-periodogram can handle non-stationary data with growing level, see chapter 6 in my 2008-book
sedat=size(edat);
weight_func=zeros(K+1,sedat(2)+1); % gdp added to depvar
% target variable

if squeeze==0
    if freqdom==0
        if standtarget
            [perall,fourtrans]=periodogram_bp((dgdpint(1:insamp)-mean(dgdpint(1:insamp)))/std(dgdpint(1:insamp)), 0, insamp);
        else
            [perall,fourtrans]=periodogram_bp(dgdpint(1:insamp), 0, insamp);
        end
    else
        gdp_q=3*dgdpint(1:3:end);
        if standtarget
            [perall,fourtrans]=periodogram_bp((gdp_q(1:fix(insamp/3))-mean(gdp_q(1:fix(insamp/3))))/std(gdp_q(1:fix(insamp/3))), 0, fix(insamp/3));
        else
            [perall,fourtrans]=periodogram_bp(gdp_q(1:fix(insamp/3)), 0, fix(insamp/3));
        end
        fourtrans=fourtrans.*[0;1-exp(-1i*[1:fix(K/3)]*pi/fix(K/3))'];
    end
else
    if standtarget
        [perall,fourtrans]=periodogram_bp((dgdpint(1+leftinfo:insamp+leftinfo)-mean(dgdpint(1+leftinfo:insamp+leftinfo)))/std(dgdpint(1+leftinfo:insamp+leftinfo)), 0, insamp);
    else
        [perall,fourtrans]=periodogram_bp(dgdpint(1+leftinfo:insamp+leftinfo), 0, insamp);
    end
end

%{
plot(abs(Gamma))
hold on
plot(abs(fourtrans)/39,'red')
hold off
%a = gca();
%a.x_ticks = tlist(["ticks" "locations" "labels"],1+(0:6)*int(K)/6,["0","pi/6","2pi/6","3pi/6","4pi/6","5pi/6","pi"])
%a.y_label.font_size = 2; 
legend('amplitude of ideal lowpass','scaled abs(DFT of interp. GDP)')
axis([-Inf +Inf -Inf 1.05])

set(gca,'XTick',1+(0:6)*fix(K)/6)
set(gca,'XTickLabel',{'0','pi/6','2pi/6','3pi/6','4pi/6','5pi/6','pi'})

print(1,'-djpeg','C:\Users\gintersb\data\latex\wp_european_indicators\target')
print(1,'-depsc','C:\Users\gintersb\data\latex\wp_european_indicators\target')
print(1,'-dpdf','C:\Users\gintersb\data\latex\wp_european_indicators\target')
print(1,'-dpng','C:\Users\gintersb\data\latex\wp_european_indicators\target')
%}

%xs2jpg(0,'C:\Ginters\IKP flash\latex\euro_light\gamma_lp_ideal')
%xs2pdf(0,'C:\Ginters\IKP flash\latex\euro_light\gamma_lp_ideal')
%xs2eps(0,'C:\Ginters\IKP flash\latex\euro_light\gamma_lp_ideal')



weight_func(1:length(fourtrans),1)=fourtrans;
%plot(abs(weight_func(:,1)))
% explaining variables          
% they aren't integrated, so I do not diff them here
if squeeze==0
if length(weight_func(1,:))>1
    for j = 1:length(edat(1,:))
        [perall,fourtrans]=periodogram_bp(edat(1:insamp,j), 0, insamp);
        weight_func(:,j+1)=fourtrans;
    end
end
end
if squeeze==1
if length(weight_func(1,:))>1
    for j = 1:length(edat(1,:))
        [perall,fourtrans]=periodogram_bp(edat(1+leftinfo:insamp+leftinfo,j), 0, insamp);
        weight_func(:,j+1)=fourtrans;
    end
end
end

%plot(abs(weight_func(:,1)),'blue')
%hold on
%plot(abs(weight_func(:,2:end)))
%ylabel('Amplitude')
%a = gca();
%a.x_ticks = tlist(['ticks' 'locations' 'labels'],1+(0:6)*int(K)/6,['0','pi/6','2pi/6','3pi/6','4pi/6','5pi/6','pi'])
%a.y_label.font_size = 2; 
%hold off
%xs2jpg(0,'C:\Ginters\IKP flash\latex\dfa_intro\dft_all')
%xs2pdf(0,'C:\Ginters\IKP flash\latex\dfa_intro\dft_all')
%xs2eps(0,'C:\Ginters\IKP flash\latex\dfa_intro\dft_all')


% weight_func(2,:) transposing a complex number changes signs

% if i1<-T then weight_constraint imposes corresponding values of amplitude functions in frequency zero
%%% compute correlation between target and explanatory vars

corr_vec=zeros(1,size(edat,2));

for jjj=1:size(edat,2)
    %corr_vec(jjj)=corr((dgdpint(1-min(0,Lag):endsamp)-nanmean(dgdpint(1-min(0,Lag):endsamp)))/nanstd(dgdpint(1-min(0,Lag):endsamp)),edat(1:endsamp+min(0,Lag),jjj));
    corr_vec(jjj)=corr((dgdpint(1:endsamp)-nanmean(dgdpint(1:endsamp)))/nanstd(dgdpint(1:endsamp)),edat(1:endsamp,jjj));
end
    
% weight_func(2,:) transposing a complex number changes signs

% if i1<-T then weight_constraint imposes corresponding values of amplitude functions in frequency zero
emphasizetargetamp=0;
swf=size(weight_func);
if ~filterdepvar
    if ~weightbycorr
        weight_constraint=playground*ones(1,swf(2)-1)/min(numbseries,swf(2)-1); % playground=1 - lowpass!!!
    else
        weight_constraint=playground*corr_vec/sum(corr_vec);
    end
    
else
    if ~weightbycorr
        weight_constraint_target=(1+emphasizetargetamp)*(1/min(numbseries+1,swf(2)));
        weight_constraint=(playground-weight_constraint_target)*ones(1,swf(2)-1)/min(numbseries,swf(2)-1); % playground=1 - lowpass!!!
    else
        weight_constraint_target=(1+emphasizetargetamp)*(1/min(numbseries+1,swf(2)));
        weight_constraint=(playground-weight_constraint_target)*corr_vec/sum(corr_vec); % playground=1 - lowpass!!!
    end
end

%if shift_constraint_lag
%    shift_constraint=Lag*ones(1,length(weight_constraint));
%else
    shift_constraint=zeros(1,length(weight_constraint));
%end

%plot((abs(weight_func(2:end,:))));

%---------------------------------------------------------------------
% 3. COMPUTATION OF FILTER PARAMETERS AND FILTERED SERIES

if filterdepvar==0
    xfag=NaN(len,1);
else
    xfag=NaN(len-(edatsize(1)-dgdpintsize(1)),1);
end
reverag=zeros(1,1);
aicag=zeros(1,1);
dgr=zeros(2,1);
numbofvars=min(numbseries,edatsize(2)); % # vars cannot exceed data dimension
combin=nchoosek(1:sedat(2),numbofvars);
sizecombin=size(combin);
for ii=1:sizecombin(1)
    selwhat=combin(ii,:);
    k_sel=numbofvars; 
    L=max(minfilterlength,min(maxfilterlength,fix(insamp/(rtio*k_sel)))); %23 for k_sel=5
    if filterdepvar==0
        [b,trf,rever,degrees_freedom,aic,freezed_degrees,accuracy,smoothness,timeliness,ms_error]=mdfa_analytic_new2(K,L,lambda,weight_func(:,[1,1+selwhat]),Lag,Gamma,expweight,cutoff,i1,i2,weight_constraint((selwhat)),lambda_cross,lambda_decay,lambda_smooth,lin_expweight,shift_constraint);
        xx=edat(:,selwhat);
        sx=size(xx);
        xf=nan(len,1);
        for i = L:filteroutputlength   
            xf(i)=0;
            for j = 1:sx(2)
                xf(i)=xf(i)+b(:,j)'*xx(i:-1:i-L+1,j);
            end
        end
        xfag(:,ii)=xf;
        reverag(ii)=rever;
        aicag(ii)=aic;
        dgr(:,ii)=[degrees_freedom;freezed_degrees];
    else
        [b,trf,rever,degrees_freedom,aic,freezed_degrees]=mdfa_analytic_new(K,L,lambda,weight_func(:,[1,1,1+selwhat]),Lag,Gamma,expweight,cutoff,i1,i2,[weight_constraint(1),weight_constraint((selwhat))],lambda_cross,lambda_decay,lambda_smooth);
  
        % filter the series
    xx=edat(:,selwhat);
    xx=xx(edatsize(1)-dgdpintsize(1)+1:end,:);
    xx=[dgdpint,xx];
    sx=size(xx);
    xf=nan(len-(edatsize(1)-dgdpintsize(1)),1);
    for i = L:filteroutputlength-(edatsize(1)-dgdpintsize(1))   
            xf(i)=0;
            for j = 1:sx(2)
                xf(i)=xf(i)+b(:,j)'*xx(i:-1:i-L+1,j);
            end
    end
    xfag(:,ii)=xf;
    reverag(ii)=rever;
    aicag(ii)=aic;
    dgr(:,ii)=[degrees_freedom;freezed_degrees];
    end
end



%plot filter coefficients
%{
 plot(b,'black')
 legend('prod.ind','order.book.ind','stocks.ind','prod.expect.ind','empl.expect.ind','build.conf','retail.conf','consumers.conf','service.conf','Location','NorthEast')
 %NorthEast SouthWest
%legend('GDP','Location','NorthEast')
      
print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_noshrink')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_noshrink')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1stconstr')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1stconstr')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2ndconstr')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2ndconstr')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_01')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_01')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_01')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_01')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_01')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_01')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1st_ld0_1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1st_ld0_1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2nd_ld0_1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2nd_ld0_1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_bothc_ld0_1')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_bothc_ld0_1')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc9_qoq_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc9_qoq_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_1st_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_1st_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_1st_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_1st_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_noexpw_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_noexpw_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_expw_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_expw_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_2st_expw_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_2st_expw_coef')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\41var_lv_qoq_coef')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\41var_lv_qoq_coef')



%filter amplitude
%K=89
%K=95
plot(abs(trf),'black')
set(gca,'XTick',1+(0:6)*fix(K)/6)
set(gca,'XTickLabel',{'0','pi/6','2pi/6','3pi/6','4pi/6','5pi/6','pi'})
legend('prod.ind','order.book.ind','stocks.ind','prod.expect.ind','empl.expect.ind','build.conf','retail.conf','consumers.conf','service.conf','Location','NorthEast')
%legend('GDP','Location','NorthEast')


print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_noshrink_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_noshrink_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1stconstr_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1stconstr_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2ndconstr_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2ndconstr_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_01_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_01_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls0_1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ls1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_01_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_01_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc0_1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_lc1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_01_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_01_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld0_1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_ld1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1st_ld0_1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_1st_ld0_1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2nd_ld0_1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_2nd_ld0_1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\9var_bothc_ld0_1_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\9var_bothc_ld0_1_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc9_qoq_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc9_qoq_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_1st_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_1st_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_1st_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_1st_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_noexpw_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_noexpw_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_expw_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc3_qoq_2st_expw_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_2st_expw_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\72var_frc6_qoq_2st_expw_amp')

print(1,'-depsc','C:\Users\gintersb\data\latex\regularized_mdfa\41var_lv_qoq_amp')
print(1,'-dpng','C:\Users\gintersb\data\latex\regularized_mdfa\41var_lv_qoq_amp')

%}


%finite symmetric

lambda1fin=lambda1;
ordfin=15; % finite symmetric
b1fin=[lambda1fin/pi,(1/pi)*sin(lambda1fin*(1:ordfin))./(1:ordfin)];
b1finc=b1fin/(sum(b1fin)+sum(b1fin(2:ordfin+1)));


%    if logquery==1 
%         gdpint1_=log(gdpint);
%         dgdpint_=100*(gdpint1_(4:end)-gdpint1_(1:end-3));  % seas diff
%     else
%         dgdpint_=100*(gdpint(4:end)./gdpint(1:end-3) - 1);  % seas diff, percentage
%     end


sizefinsym=size(b1fin);
inputvar=3*dgdpint;
sizeivar=size(inputvar);
dgdp_finsym=NaN(sizeivar);
meanvar=mean(inputvar);
ivar=inputvar-meanvar;
for i=sizefinsym(2):sizeivar(1)-sizefinsym(2)+1
    dgdp_finsym(i)=[b1finc(end:-1:2),b1finc]*ivar(i-sizefinsym(2)+1:i+sizefinsym(2)-1);
end
dgdp_finsym=dgdp_finsym+meanvar;

%plot(dgdp_finsym)
%hold on
%plot(dgdpint_)
%hold off


xfagav=xfag*(reverag.^(-pp))'/sum(reverag.^(-pp));
reveragav=reverag*(reverag.^(-pp))'/sum(reverag.^(-pp))
aicagav=aicag*(aicag.^(-pp))'/sum(aicag.^(-pp))
for iii=1:2
    dgrav(iii)=dgr(iii,:)*(dgr(iii,:).^(-pp))'/sum(dgr(iii,:).^(-pp));
end
dgrav




%[euro_light_data,euro_light_string]=xlsread('C:\Users\gintersb\data\database\euro_light_publish_vintage.xls');

%[eurocoin_data,eurocoin_string]=xlsread('C:\Users\gintersb\data\latex\regularized_mdfa\m-code\eurocoin.xlsx');

%close all
vari=xfagav;
%sizevar=size(vari);
%L=max(minfilterlength,min(maxfilterlength,fix(insamp/(rtio*numbseries))));
endpoint=insamp;


      if nostand
         filtermatrix = vari;
      else
          filtermatrix = (vari - mean(vari(max(L,ordfin+1):dgdpintsize(1)-ordfin)))/std(vari(max(L,ordfin+1):dgdpintsize(1)-ordfin))*std(dgdp_finsym(max(L,ordfin+1):dgdpintsize(1)-ordfin))+mean(dgdp_finsym(max(L,ordfin+1):dgdpintsize(1)-ordfin));
      end


  
      
    finaloutput=filtermatrix;

    
    
vari=finaloutput;



